<template>
  <Container
    class="h-full border-b-4 border-gray-300"
    :style="{ borderBottomColor: booking.comment && booking.property.color }"
  >
    <section class="flex items-center justify-between gap-2">
      <SectionHeader icon="mdi-comment-alert-outline">
        Комментарий
      </SectionHeader>

      <v-btn
        variant="tonal"
        class="text-amber-600 flex-initial"
        size="small"
        icon="mdi-pencil"
        @click="isEditShown = true"
      />
    </section>

    <section v-if="booking.comment">
      {{ booking.comment }}
    </section>

    <section
      v-else
      class="text-gray-400"
    >
      Комментария нет
    </section>
  </Container>

  <v-dialog
    v-model="isEditShown"
    persistent
  >
    <FloatingContainer>
      <FormHeader
        icon="mdi-pencil-outline"
        headline="Изменение комментария"
        subtitle="Заполните данные"
      />

      <section class="pt-4">
        <FormRow label="Ваш комментарий">
          <v-textarea
            v-model="updatedComment"
            :maxlength="MAX_BOOKING_COMMENT_LENGTH"
            prepend-inner-icon="mdi-comment-edit-outline"
            variant="solo-filled"
            persistent-counter
            clearable
            auto-grow
            flat
            counter
          />
        </FormRow>

        <FormRow spacing="large">
          <v-btn
            block
            rounded
            size="large"
            class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            @click="onCommentUpdate"
          >
            Изменить
          </v-btn>
        </FormRow>

        <FormRow>
          <v-btn
            block
            rounded
            size="small"
            variant="plain"
            :ripple="false"
            class="font-bold"
            @click="onCommentUpdateCancel"
          >
            Отмена
          </v-btn>
        </FormRow>
      </section>
    </FloatingContainer>
  </v-dialog>
</template>

<script setup lang="ts">
import { ref, watch } from 'vue';

import { MAX_BOOKING_COMMENT_LENGTH } from '@/declarations';

import Container from '@/components/layout/Container.vue';
import SectionHeader from '@/components/layout/SectionHeader.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import FormRow from '@/components/layout/FormRow.vue';
import FloatingContainer from '@/components/layout/FloatingContainer.vue';

const props = defineProps<{ booking: IVerboseBooking }>();
const emit = defineEmits(['update:comment']);

const isEditShown = ref(false);
const updatedComment = ref(props.booking.comment ?? '');

const onCommentUpdate = () => {
  const trimmedComment = updatedComment.value.trim();
  const commentValue = trimmedComment || null;

  isEditShown.value = false;
  emit('update:comment', commentValue);
};

const onCommentUpdateCancel = () => {
  isEditShown.value = false;
  updatedComment.value = props.booking.comment ?? '';
};

watch(isEditShown, () => {
  updatedComment.value = props.booking.comment ?? '';
});
</script>